function H = wood_hessian(x1, x2, x3, x4)
  ##
  ## The Hessian of the Wood function. See wood.m for more
  ## information.
  ##
  H = zeros(4,4);
  H(1,1) = 1200*x(1)^2 - 400*x(2) + 2;
  H(1,2) = -400*x(1);
  H(1,3) = 0;
  H(1,4) = 0;
  H(2,1) = H(1,2);
  H(2,2) = 220.2;
  H(2,3) = 0;
  H(2,4) = 19.8;
  H(3,1) = H(1,3);
  H(3,2) = H(2,3);
  H(3,3) = 1080*x(3)^2 - 360*x(4) + 2;
  H(3,4) = -360*x(3);
  H(4,1) = H(1,4);
  H(4,2) = H(2,4);
  H(4,3) = H(3,4);
  H(4,4) = 200.2;
end
