function g = rosenbrock_gradient1(x)
  ##
  ## A version of the rosenbrock_gradient() function which takes a
  ## column 2-vector instead of two distinct arguments. See
  ## rosenbrock_gradient.m for more information.
  ##
  if (length(x) == 2)
    g = rosenbrock_gradient(x(1), x(2));
  else
    g = NA;
  end
end
